/**
  * This Class encapsulates the the creation of all of the data structures used by
 * a Presentation Manager Front end.
 * Creation date: (04/13/00 23:55:10)
 * @author:Erik Ordway
 The Presentation Manager

The NetLab Project of The Evergreen State College
		  
Java code 
Copyright   2000 by Erik Ordway crainm@techie.com

Non Module specific html, css, and graphics
Copyright   2000 by Brook Hatch

Module specific html, css, and graphics
Copyright   2000 by the Authors of the module

Welcome to The Presentation Manager. This document covers is the licences of The Presentation Manager Release 4.0.
This program and its accompaning modules are a work in progress and are the work of many individuals. If you are 
interested in helping with this project, please contact the NetLab project at http://grace.evergreen.edu/nsl. 
The latest version of this program is always available from the NetLab Wide Web server. It may also 
be downloaded in a variety of formats and compression options from the NetLab web server or run from that site.

Redistribution and use in source java code, html, css, and graphics  and 'compiled' forms java bytecode with or
 without modification, are permitted provided that the following conditions are met:

Redistributions of source code java source code must retain the above copyright notice, this list of conditions 
and the following disclaimer as the first lines of this file unmodified.

Redistributions in compiled form java bytecode with accompaning modules and support html, css, and graphincs  
must reproduce the above copyright notice, this list of conditions and the following disclaimer in the 
documentation and/or other materials provided with the distribution.

Important: THIS PROGRAM AND ITS ACCOMPANING MODULES ARE PROVIDED BY THE NETLAB PROJECT AND ITS AUTHORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE NETLAB PROJECT BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 */
import java.io.*;
import java.net.URL;
import java.net.MalformedURLException;
import javax.swing.*;
import javax.swing.text.html.*;
import javax.swing.SwingUtilities.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.util.Enumeration;
import java.util.Vector;
import java.lang.String;
import javax.accessibility.*;
import java.applet.*;
class DBWrapper
{
	protected Loader load = new Loader();
	private Glossary_db glossaryDB = new Glossary_db();
	private Keyword_db keywordDB;
	protected Modules_db modules;
	protected java.applet.AppletContext context;
	
/**
 * Wrapper constructor comment.
 */
public DBWrapper() {
	super();
}
/**
 * Wrapper constructo.  This action of the costuctor is done by buildData().
 */
public DBWrapper( java.applet.AppletContext context, URL codebase ) {
	super();
	setContext(context);
	buildData(codebase);
	return;
}
/**
 * This method contains all the data structures use by a front end such as PMembedable.
 * an instance of the class Loader() is created and then calle to fill the data structures
 * Creation date: (04/13/00 23:59:44)
 */
private void buildData(URL url)
{ //Setting context with the applets browser context

	

	//run the modules list from Loader()
	load.loadModules(url.toString()); 
	int i = 1;
	setModules();
	//end load modules list

	//begin load Glossary
	context.showStatus("Loading Glossary information from Modules");
	glossaryDB = new Glossary_db();
	load.loadGlossary(glossaryDB);
	load.loadHeadNTail(url, glossaryDB, "modules/glossary.htm");
	//end load Glossary

	//begin load Keyword
	context.showStatus("Loading Keyword information");
	keywordDB = new Keyword_db();
	load.loadKeyword(keywordDB);
	load.loadHeadNTail(url, keywordDB, "modules/keywords.htm");
	//end load Keyword

	
	context.showStatus("All information has been loaded");
	load = null;
}
/**
 * Insert the method's description here.
 * Creation date: (04/14/00 00:06:00)
 * @return java.applet.AppletContext
 */
public java.applet.AppletContext getContext() {
	return context;
}
/**
 * Insert the method's description here.
 * Creation date: (04/14/00 00:06:00)
 * @return Glossary_db
 */
public Glossary_db getGlossaryDB() {
	return glossaryDB;
}
/**
 * Insert the method's description here.
 * Creation date: (04/14/00 00:06:00)
 * @return Keyword_db
 */
public Keyword_db getKeywordDB() {
	return keywordDB;
}
/**
 * Insert the method's description here.
 * Creation date: (04/14/00 00:06:00)
 * @return Loader
 */
public Loader getLoad() {
	return load;
}
/**
 * Insert the method's description here.
 * Creation date: (04/14/00 00:06:00)
 * @return Modules_db
 */
public Modules_db getModules() {
	return modules;
}
/**
 * Insert the method's description here.
 * Creation date: (04/14/00 00:06:00)
 * @param newContext java.applet.AppletContext
 */
protected void setContext(java.applet.AppletContext newContext) {
	context = newContext;
}
/**
 * Insert the method's description here.
 * Creation date: (04/14/00 00:06:00)
 * @param newGlossaryDB Glossary_db
 */
private void setGlossaryDB(Glossary_db newGlossaryDB) {
	glossaryDB = newGlossaryDB;
}
/**
 * Insert the method's description here.
 * Creation date: (04/14/00 00:06:00)
 * @param newKeywordDB Keyword_db
 */
private void setKeywordDB(Keyword_db newKeywordDB) {
	keywordDB = newKeywordDB;
}
/**
 * Insert the method's description here.
 * Creation date: (04/14/00 00:06:00)
 * @param newLoad Loader
 */
private void setLoad(Loader newLoad) {
	load = newLoad;
}
/**
 * Insert the method's description here.
 * Creation date: (04/14/00 00:06:00)
 * @param newModules Modules_db
 */
protected void setModules() {
	modules = load.getModules();
}
}
