import java.util.Vector;
import java.util.Enumeration;
/**
 * a generic set of data and methods to be used by subclasses of it.
 * Creation date: (03/22/00 18:25:42)
 * @author:  Erik Ordway
 The Presentation Manager

The NetLab Project of The Evergreen State College
		  
Java code 
Copyright   2000 by Erik Ordway crainm@techie.com

Non Module specific html, css, and graphics
Copyright   2000 by Brook Hatch

Module specific html, css, and graphics
Copyright   2000 by the Authors of the module

Welcome to The Presentation Manager. This document covers is the licences of The Presentation Manager Release 4.0.
This program and its accompaning modules are a work in progress and are the work of many individuals. If you are 
interested in helping with this project, please contact the NetLab project at http://grace.evergreen.edu/nsl. 
The latest version of this program is always available from the NetLab Wide Web server. It may also 
be downloaded in a variety of formats and compression options from the NetLab web server or run from that site.

Redistribution and use in source java code, html, css, and graphics  and 'compiled' forms java bytecode with or
 without modification, are permitted provided that the following conditions are met:

Redistributions of source code java source code must retain the above copyright notice, this list of conditions 
and the following disclaimer as the first lines of this file unmodified.

Redistributions in compiled form java bytecode with accompaning modules and support html, css, and graphincs  
must reproduce the above copyright notice, this list of conditions and the following disclaimer in the 
documentation and/or other materials provided with the distribution.

Important: THIS PROGRAM AND ITS ACCOMPANING MODULES ARE PROVIDED BY THE NETLAB PROJECT AND ITS AUTHORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE NETLAB PROJECT BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 * 
 */
class Generic_db {
	protected java.util.Vector item_vector ;
	protected java.util.Vector sorted_item_vector ;
	protected java.lang.String htmlString;
	protected boolean sorted;
	protected java.lang.String htmlHead;
	protected java.lang.String htmlTail;
/**
 * Generic_db constructor initialize the data fields.
 */
public Generic_db() {
	super();
	item_vector = new java.util.Vector();
	sorted_item_vector = new java.util.Vector();
	sorted = false;
}
/**
 * This method is used to add a new item to th item_vector
 * Creation date: (02/26/00 17:51:36)
 */
public void addItem(Generic_item newGlossaryItem) {
	//System.out.println("in Glosary_db.addGlosaryItem");
	item_vector.addElement(newGlossaryItem);
	}
/** 
* gets the parsed tail of the /Presentation_Manager/*.htm file that is used in display
 * of (about || keyword || glossary) information in the applets.
 * Creation date: (04/25/00 15:09:18)
 * @return java.lang.String
 */
public java.lang.String getHtmlHead() {
	return htmlHead;
}
/**
 * gets the parsed tail of the /Presentation_Manager/*.htm file that is used in display
 * of (about || keyword || glossary) information in the applets.
 * Creation date: (04/25/00 15:09:40)
 * @return java.lang.String
 */
public java.lang.String getHtmlTail() {
	return htmlTail;
}
/**
 * get the vector of objects that is the point of the class
 * Creation date: (02/26/00 17:50:59)
 * @return java.util.Vector
 */
public Vector getItem_vector() {
	return item_vector;
}
/**
 * checks a check bollean that is used to avoid reSorting() the item_vector for display.
 * Creation date: (03/27/00 21:43:02)
 * @return boolean
 */
public boolean isSorted() {
	return sorted;
}
/**
 * Searches to see if a word is in a Generic_db.  
 * This version does a search based on the first three letters
 * in addition to a caseless whole word match.
 * Creation date: (03/25/00 19:19:34)
 * @return java.util.Vector
 * @param word java.lang.String
 * @exception java.lang.Error The exception description.
 */
public Vector search(String word) throws java.lang.Error
{
	Vector results = new Vector();

	//search based on wholle word mathches
	Enumeration gItems = item_vector.elements();
	if (gItems.hasMoreElements())
	{
		while (gItems.hasMoreElements())
		{
			Generic_item gItem = (Generic_item) gItems.nextElement();
			String String1 = gItem.getWord().toLowerCase();
			//System.out.println(String1);
			String String2 = word.toLowerCase().toString();
			//System.out.println(String1);
			if (String1.equals(String2))
			{
				results.addElement(gItem);
			}
		}
	}


	//search based on the first three letters if there are no matches
	//
	//
	//{
	if (results.isEmpty())
	{
		gItems = item_vector.elements();
		if (gItems.hasMoreElements())
		{
			while (gItems.hasMoreElements())
			{
				Generic_item gItem = (Generic_item) gItems.nextElement();
				String String1 = gItem.getWord().toLowerCase();
				//System.out.println(String1);
				String String2 = word.toLowerCase().toString();
				//System.out.println(String1);
				if (String1.regionMatches(true, 0, String2, 0, 3))
				{
					results.addElement(gItem);
				}
			}
		}
	} //i--;
	//}
	if (results.isEmpty())
	{
		throw new java.lang.Error("There are no matches");
	}
	return results;
}
/**
 * Searches to see if a word is in a Generic_db.  This version does not do the search based on the first three letters
 * Creation date: (03/25/00 19:19:34)
 * @return java.util.Vector
 * @param word java.lang.String
 * @exception java.lang.Error The exception description.
 */
public Vector search(String word , boolean display) throws java.lang.Error
{
	Vector results = new Vector();

	//search based on wholle word mathches
	Enumeration gItems = item_vector.elements();
	if (gItems.hasMoreElements())
	{
		while (gItems.hasMoreElements())
		{
			Generic_item gItem = (Generic_item) gItems.nextElement();
			String String1 = gItem.getWord().toLowerCase();
			//System.out.println(String1);
			String String2 = word.toLowerCase().toString();
			//System.out.println(String1);
			if (String1.equals(String2))
			{
				results.addElement(gItem);
			}
		}
	}


	//search based on the first three letters if there are no matches
	//
	//
	//{
	if (!(display)){
	if (results.isEmpty())
	{
		gItems = item_vector.elements();
		if (gItems.hasMoreElements())
		{
			while (gItems.hasMoreElements())
			{
				Generic_item gItem = (Generic_item) gItems.nextElement();
				String String1 = gItem.getWord().toLowerCase();
				//System.out.println(String1);
				String String2 = word.toLowerCase().toString();
				//System.out.println(String1);
				if (String1.regionMatches(true, 0, String2, 0, 3))
				{
					results.addElement(gItem);
				}
			}
		}
	}} //i--;
	//}
	if (results.isEmpty())
	{
		throw new java.lang.Error("There are no matches");
	}
	return results;
}
/**
 * sets the parsed tail of the /Presentation_Manager/*.htm file that is used in display
 * of (about || keyword || glossary) information in the applets.
 * Creation date: (04/25/00 15:09:18)
 * @param newHtmlHead java.lang.String
 */
public void setHtmlHead(java.lang.String newHtmlHead) {
	htmlHead = newHtmlHead;
}
/**
 * sets the parsed tail of the /Presentation_Manager/*.htm file that is used in display
 * of (about || keyword || glossary) information in the applets.
 * Creation date: (04/25/00 15:09:40)
 * @param newHtmlTail java.lang.String
 */
public void setHtmlTail(java.lang.String newHtmlTail) {
	htmlTail = newHtmlTail;
}
/**
 * Set a check bollean that is used to avoid reSorting() the item_vector for display.
 * Creation date: (03/27/00 21:43:02)
 * @param newSorted boolean
 */
protected void setSorted(boolean newSorted) {
	sorted = newSorted;
}
/**
 * Insert the method's description here.
 * Creation date: (03/06/00 17:44:13)
 * @return int
 */
public int size() {
	return item_vector.size();
}
/**
 * recursive sort of the items contained in the passed in vector.  The returned values are in alpha order.
 * this is also used by the sortToTree() method to sort the vector of vectors.
 * Creation date: (03/27/00 22:09:41)
 * @return java.util.Vector
 * @param words java.util.Vector
 * @param position int
 */
public Vector sort(Vector words)
{	Vector returningWords = new Vector();
	int size = words.size();
	//deal with a single value
	if (size == 1)
	{
		return words;
	}
	//deal with 2 values
	if (size == 2)
	{
		if (((String) words.firstElement()).compareTo((String) words.lastElement()) <= 0)
		{
			return words;
		}
		else
		{
			words.insertElementAt(words.lastElement(), 0);
			words.removeElementAt(2);
			return words;
		}
	}
	//deal with greater than 2 values
	if (size >= 3)
	{
		//Split in two vectors
		int halfsize = size / 2;
		int i = 0;
		Vector newWords = new Vector();
		while (i <= halfsize)
		{
			Object word = words.firstElement();
			words.removeElement(word);
			newWords.addElement(word);
			i++;
		}
		//recursive pass of the vectors to new instances of sort()
		newWords = sort(newWords);
		words = sort(words);
		
		i = 0;
		while (i < size)
		{
			if ((newWords.size() > 0) & (words.size() > 0))
			{
				//Object alpha = newWords.firstElement();
				//newWords.removeElement(alpha);
				//Object beta = words.firstElement();
				//words.removeElement(beta);
				if (((String) newWords.firstElement()).compareTo((String) words.firstElement()) <= 0)
				{
					returningWords.addElement(newWords.firstElement());
					newWords.removeElement(newWords.firstElement());
					//returningWords.addElement(beta);
				}
				else
				{
					returningWords.addElement(words.firstElement());
					words.removeElement(words.firstElement());
					//returningWords.addElement(alpha);
				}
				i++;
			}
			else
			{
				if (newWords.size() > 0)
				{
					while (newWords.size() > 0){
					returningWords.addElement(newWords.firstElement());
					newWords.removeElement(newWords.firstElement());
					i++;
					}
				}
				else
				{
					while (words.size() > 0){
					returningWords.addElement(words.firstElement());
					words.removeElement(words.firstElement());
					i++;
					}
				}
			}
		}
	}
	//this should be some sort of recusive sort.
	return returningWords;
}
/**
 * all words are made lower case will searching and sorting this allows the this.search function
 * to be used.  This function takes the objects stored in item_vector and sorts then in to a
 * vector of vectors containing items with the same name.
 * Creation date: (03/27/00 18:59:15)

 */
protected void sortToTree()
{
	//make an Vector to store them
	Vector words = new Vector();
	//enumeration of the items in sthe vector
	Enumeration gItems = item_vector.elements();
	while (gItems.hasMoreElements())
	{
		//System.out.println("there are elements");
		Generic_item gItem = (Generic_item) gItems.nextElement();
		//catch the first element and put it in the words Vector
		if (!(words.isEmpty()))
		{
			Enumeration words_enum = words.elements();
			boolean truth = false;
			while (words_enum.hasMoreElements())
			{
				
				//System.out.println("there are elements");
				String word = (String) words_enum.nextElement();
				if (gItem.getWord().toLowerCase().equals(word))
				{
					truth = true;
					break;
				}
				else
				{
					truth = false;
				}
			}
			if (truth == false)
				words.addElement(new String(gItem.getWord().toLowerCase()));
		}
		else
		{ //catch the first element and put it in the words Vector
			words.addElement(new String(gItem.getWord().toLowerCase()));
		}
	}

	//we  now have a Vector of words that appears atleast once in the item_vector
	//sort the words alphabetcaly(sp)
	words = this.sort(words);
	
	//now lets make Vectors of each of these and put them in sorted_item_vector
	//use the this.search() function the do the seaching and put the returned Vector into the sorted_items_vector

	Enumeration words_enum = words.elements();
	while (words_enum.hasMoreElements())
	{
		//System.out.println("there are elements");
		String word = new String((String) words_enum.nextElement());
		sorted_item_vector.addElement(this.search(word,true));
	}
	this.setSorted(true);
	return;
}
}
