import java.net.URL;
/**
 * This represents the generic object that is used by Glossary, Keywords, and Modules.
 * A base set of data fields is kept here.  Of not is the value of word is returned as a
 * representation of the the object when you call Generic_item.toString().
 * Creation date: (03/22/00 18:38:43)
 * @author: Erik Ordway
 The Presentation Manager

The NetLab Project of The Evergreen State College
		  
Java code 
Copyright   2000 by Erik Ordway crainm@techie.com

Non Module specific html, css, and graphics
Copyright   2000 by Brook Hatch

Module specific html, css, and graphics
Copyright   2000 by the Authors of the module

Welcome to The Presentation Manager. This document covers is the licences of The Presentation Manager Release 4.0.
This program and its accompaning modules are a work in progress and are the work of many individuals. If you are 
interested in helping with this project, please contact the NetLab project at http://grace.evergreen.edu/nsl. 
The latest version of this program is always available from the NetLab Wide Web server. It may also 
be downloaded in a variety of formats and compression options from the NetLab web server or run from that site.

Redistribution and use in source java code, html, css, and graphics  and 'compiled' forms java bytecode with or
 without modification, are permitted provided that the following conditions are met:

Redistributions of source code java source code must retain the above copyright notice, this list of conditions 
and the following disclaimer as the first lines of this file unmodified.

Redistributions in compiled form java bytecode with accompaning modules and support html, css, and graphincs  
must reproduce the above copyright notice, this list of conditions and the following disclaimer in the 
documentation and/or other materials provided with the distribution.

Important: THIS PROGRAM AND ITS ACCOMPANING MODULES ARE PROVIDED BY THE NETLAB PROJECT AND ITS AUTHORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE NETLAB PROJECT BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 */
class Generic_item {
	protected java.net.URL link;
	protected java.lang.String modName;
	public java.lang.String word;
/**
 * Generic_item constructor comment once a the constructor is called the values of the object are
 * set from the outside.
 */
public Generic_item() {
	super();
}
/**
 * returns the URL of the module that the item belongs to.  Some subclasses of Generic_item add
 * special methods like Generic_item.getIndex() which returns a URL for the index.htm file for the module.
 * Creation date: (03/22/00 23:41:24)
 * @return java.net.URL
 */
public java.net.URL getLink() {
	return link;
}
/**
 * Return the name the the module belongs.
 * Creation date: (03/22/00 18:43:00)
 * @return java.lang.String
 */
public java.lang.String getModName() {
	return modName;
}
/**
 * For Glossary and Keywords this is used the store the searchable value.  It is unused in modules.
 * Creation date: (03/25/00 20:28:51)
 * @return java.lang.String
 */
public java.lang.String getWord() {
	return word;
}
/**
 * See the equivilant get*()
 * Creation date: (03/22/00 23:41:24)
 * @param newLink java.net.URL
 */
public void setLink(java.net.URL newLink) {
	link = newLink;
}
/**
 * See the equivilant get*()
 * Creation date: (03/22/00 18:43:00)
 * @param newModName java.lang.String
 */
public void setModName(java.lang.String newModName) {
	modName = newModName;
}
/**
 * See the equivilant get*()
 * Creation date: (03/25/00 20:28:51)
 * @param newWord java.lang.String
 */
protected void setWord(java.lang.String newWord) {
	word = newWord;
}
/**
 * Returns a String that represents the value of this object.
 * @return a string representation of the receiver
 */
public String toString() {
	// Insert code to print the receiver here.
	// This implementation forwards the message to super. You may replace or supplement this.
	return modName;
}
}
