/**
 * Utility class used to load the various files used the system
 * Creation date: (02/27/00 11:18:49)
 * @author:  Erik Ordway
 The Presentation Manager

The NetLab Project of The Evergreen State College
		  
Java code 
Copyright   2000 by Erik Ordway crainm@techie.com

Non Module specific html, css, and graphics
Copyright   2000 by Brook Hatch

Module specific html, css, and graphics
Copyright   2000 by the Authors of the module

Welcome to The Presentation Manager. This document covers is the licences of The Presentation Manager Release 4.0.
This program and its accompaning modules are a work in progress and are the work of many individuals. If you are 
interested in helping with this project, please contact the NetLab project at http://grace.evergreen.edu/nsl. 
The latest version of this program is always available from the NetLab Wide Web server. It may also 
be downloaded in a variety of formats and compression options from the NetLab web server or run from that site.

Redistribution and use in source java code, html, css, and graphics  and 'compiled' forms java bytecode with or
 without modification, are permitted provided that the following conditions are met:

Redistributions of source code java source code must retain the above copyright notice, this list of conditions 
and the following disclaimer as the first lines of this file unmodified.

Redistributions in compiled form java bytecode with accompaning modules and support html, css, and graphincs  
must reproduce the above copyright notice, this list of conditions and the following disclaimer in the 
documentation and/or other materials provided with the distribution.

Important: THIS PROGRAM AND ITS ACCOMPANING MODULES ARE PROVIDED BY THE NETLAB PROJECT AND ITS AUTHORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE NETLAB PROJECT BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 */
 import java.util.Vector;
import java.io.*;
import java.net.*;
class Loader {

	private Modules_db modules;
/**
 * Loader constructor comment.
 */
public Loader() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (02/27/00 13:16:39)
 * @param newGlossaryDB Glossary_db
 */
private void addItemGlossaryDB(Glossary_item newGlossaryItem ,Glossary_db  glosDB) {
	glosDB.addItem(newGlossaryItem);
}
/**
 * Insert the method's description here.
 * Creation date: (02/27/00 13:17:14)
 * @param newKeywordDB Glossary_db
 */
private void addItemKeywordDB(Keyword_item newKeywordDB , Keyword_db keyDB) {
	keyDB.addItem(newKeywordDB);
}
/**
 * Insert the method's description here.
 * Creation date: (03/04/00 13:32:47)
 * @return java.util.Vector
 */
public Modules_db getModules() {
	return modules;
}
/**
 * Insert the method's description here.
 * Creation date: (03/06/00 16:49:10)
 * @param param Glossary_db
 * @param modURL java.net.URL
 */
public void insertModGlos(Glossary_db glos, URL modURL, String moduleName)
{
	LineNumberReader file;
	String line = new String();
	Glossary_item item;
	String term;
	StringBuffer def = new StringBuffer();
	String urlString;
	URL shortURL = modURL;
	int begin;
	int end;
	int filler;
	try
	{
		file = new LineNumberReader(new InputStreamReader((modURL.openStream())));
		int i = 1;
		while (line != null)
		{
			try
			{
				line = file.readLine();
				//System.out.println(i);

				if (line != null)
				{
					if (line.startsWith("<entry>"))
					{ //catch the begining of the entry and then enter it into the glossaryDB  
						//get term string
						//line = file.readLine();
						//System.out.println(line);
						line = file.readLine();
						
						
						begin = line.indexOf("<term>") + 6;
						end = line.indexOf("</term>");
						term = line.substring(begin, end);

						
						//System.out.println(term);
						
						//modify URL to point to module/*/index.html
						urlString = modURL.toString();
						urlString = urlString.substring(0, urlString.length() - 12);
						urlString = urlString.concat("content/index.htm");
						try
						{
							shortURL = new URL(urlString);
						}
						catch (MalformedURLException e)
						{
							System.out.println("url creating failed in insertModGlos");
						}
						//get defintion
						def = new StringBuffer();
						String defString = file.readLine();
						while (!(defString.startsWith("</entry>")))
						{
							def.append(defString);
							defString = file.readLine();
						}

						
						//insert the new entry into the database

						item = new Glossary_item(term, moduleName, def.toString(), shortURL);
						glos.addItem(item);
					}
					if (line.startsWith("//"))
					{ //stop reading the file to avoided reading comments
						line = null;
					}
					//if (line.startsWith("</entry>")) { //stop reading the file to avoided reading comments
					//	filler = 0;
					//}
				}
			}
			catch (IOException e)
			{
				System.out.println("read line failed");
				line = null;
			}
		}
	}
	catch (IOException e)
	{
		System.out.println("The file glossary.htm in the following module was unavailable for reading Glossary items:");
		System.out.println(moduleName);
		System.out.println("\n the file was thought to be at:");
		System.out.println(shortURL.toString());
	}
}
/**
 * Insert the method's description here.
 * Creation date: (03/06/00 16:49:10)
 * @param param Glossary_db
 * @param modURL java.net.URL
 */
public void insertModKey(Keyword_db key, URL modURL, String moduleName)
{
	LineNumberReader file;
	String line = new String();
	StringBuffer lineBuffer = new StringBuffer();
	Keyword_item item;
	String term = new String();
	StringBuffer def = new StringBuffer();
	String urlString = (modURL.toString()).substring(0, modURL.toString().length() - 12);
	URL link = modURL;
	int begin;
	int end;
	int filler;
	try
	{
		file = new LineNumberReader(new InputStreamReader((modURL.openStream())));
		int i = 1;
		while (line != null)
		{
			try
			{
				line = file.readLine();
				//System.out.println(i);

				if (line != null)
				{
					if (!(line.startsWith("<modkey>")||line.startsWith("//")))
					{ //stuff to read keywords here
						lineBuffer = new StringBuffer(line);
						lineBuffer.insert(12, urlString.toString());
						//get word
						line = lineBuffer.toString();
						begin = line.indexOf("<word>") + 6;
						end = line.indexOf("</word>");
						term = line.substring(begin, end);

						//GET URL				
						begin = line.indexOf("\"") + 1;
						end = line.lastIndexOf("\"");
						line = line.substring(begin, end);
						//MAKE url 
						try
						{
							link = new URL(line);
						}
						catch (MalformedURLException e)
						{
							System.out.println("url creating failed in insertModKey");
						}
						//create a new Keyword_item
						item = new Keyword_item(term, moduleName, true, link, lineBuffer.toString());
						//add it to the Keyword_db
						key.addItem(item);
					}
					if (line.startsWith("<modkey>"))
					{ //stuff to read module level keywords here
						//modify url to point at the full path 
						lineBuffer = new StringBuffer(line);
						lineBuffer.insert(20, urlString.toString());

						//get word
						line = lineBuffer.toString();
						begin = line.indexOf("<word>") + 6;
						end = line.indexOf("</word>");
						term = line.substring(begin, end);

						//GET URL				
						begin = line.indexOf("\"") + 1;
						end = line.lastIndexOf("\"");
						line = line.substring(begin, end);
						//MAKE url 
						try
						{
							link = new URL(line);
						}
						catch (MalformedURLException e)
						{
							System.out.println("url creating failed in insertModKey");
						}
						//create a new Keyword_item
						item = new Keyword_item(term, moduleName, true, link, lineBuffer.toString());
						//add it to the Keyword_db
						key.addItem(item);
					}
					if (line.startsWith("//"))
					{ //stop reading the file to avoided reading comments
						line = null;
					}
				}
			}
			catch (IOException e)
			{
				System.out.println("read line failed");
				line = null;
			}
		}
	}
	catch (IOException e)
	{
		System.out.println("The file keywords.htm in the following module was unavailable for reading Keywords:");
		System.out.println(moduleName);
		System.out.println("\n the file was thought to be at:");
		System.out.println(urlString);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (02/27/00 11:33:32)
 * @param url java.lang.String
 */
public Glossary_db loadGlossary(Glossary_db glossaryDB)
{
	//
	/*
	open each module glossary file 
	read the file
	make Glossary_items
	then use addItemGlossaryDB(GLossary_item)
	then close file
	read next file
	write the .htm file that will be displayed
	*/
	String glosString;
	URL glosURL;
	//int count = (modules.size() - 1);
	//int i = 0;
	java.util.Enumeration mod = modules.getItem_vector().elements();
	if (mod.hasMoreElements())
	{ 
		while (mod.hasMoreElements())
		{
			//System.out.println("there are elements");
			//System.out.println("in loadGlossary(Glossary_db glossaryDB)");
			Modules_item item = (Modules_item) mod.nextElement();
			glosString = item.getLink().toString();
			glosString = glosString.concat("/glossary.htm");
			String moduleName = item.toString();
			//System.out.println(glosString);
			try
			{
				//i++;
				glosURL = new URL(glosString);
				insertModGlos(glossaryDB, glosURL ,moduleName);
		 	}
			catch (MalformedURLException e)
			{
				System.out.println("URL was malformed");
			}
			//System.out.println(line);
			//i++;
			//System.out.println("out loadGlossary(Glossary_db glossaryDB)");
		}
	}
	else
		System.out.println("there be no elements here");
	//glossaryDB.makeHtmlString();
	return glossaryDB;
}
/**
  * given the base of where the applet is running
 * the function will fill in the data for the head and tail of the
 * splash screen.  the rest of the data will be loaded by another method
 * no cheching is done if said about.(head || tail) files exist.
 * If they do not the strings will be empty.
 * also "/" is used as a separator which may not be platform independat
 * only file type expections are caught and the about.(head || tail) files are 
 * expected to be syntacticly correct.
 * Creation date: (02/27/00 14:56:03)
 * @param url java.lang.String
 */
public void loadHeadNTail(URL codebase, Generic_db owner, String filename)
{
	String headFile = new String(codebase.toString().concat(filename));
	StringBuffer temphead = new StringBuffer();
	StringBuffer temptail = new StringBuffer();
	StringBuffer temp;
	URL url;
	URL moduleURL;
	LineNumberReader file;
	String breakTag = new String("<!--break-->");
	String line = new String();
	temp = temphead;
	try
	{
		url = new URL(headFile);
		try
		{
			file = new LineNumberReader(new InputStreamReader((url.openStream())));
			while (line != null)
			{
				try
				{
					line = file.readLine();
					if (line != null)
					{
						//System.out.println(line);
						if ((line.toLowerCase()).startsWith(breakTag))
						{
							line = file.readLine();
							//System.out.println(temp);
							//System.out.println("\n");
							temp = temptail;
						}
						
							temp.append(line);
						
					}
				}
				catch (IOException e)
				{
					System.out.println("read line failed");
					line = null;
				}
			}
		}
		catch (IOException e)
		{
			System.out.println("The file about.htm used for generating the head and tail of the gloassry or keywords \n screen was unavailable for reading:");
			System.out.println("\n the file was thought to be at:");
			System.out.println(headFile);
		}
	}
	catch (MalformedURLException e)
	{
		System.out.println("URL is malformend");
	}

	//System.out.println(temp);
	//System.out.println("\n");
	owner.setHtmlHead(temphead.toString());
	
	owner.setHtmlTail(temptail.toString());
	return;
}
/**
 * Insert the method's description here.
 * Creation date: (02/27/00 11:34:07)
 * @param url java.lang.String
 */
public Keyword_db loadKeyword(Keyword_db KeywordDB) {
	
	//
	/*
	open each module keyword files 
	read the file
	make Keyword_items
	then use addItemKeywordDB(Keyword_item)
	then close file
	read next file
	*/
	String keyString;
	URL keyURL;
	//int count = (modules.size() - 1);
	//int i = 0;
	java.util.Enumeration mod = modules.getItem_vector().elements();
	if (mod.hasMoreElements())
	{ 
		while (mod.hasMoreElements())
		{
			//System.out.println("there are elements");
			Modules_item item = (Modules_item) mod.nextElement();
			keyString = item.getLink().toString();
			keyString = keyString.concat("/keywords.htm");
			String moduleName = item.toString();
			//System.out.println(glosString);
			try
			{
				//i++;
				keyURL = new URL(keyString);
				insertModKey(KeywordDB, keyURL ,moduleName);
		 	}
			catch (MalformedURLException e)
			{
				System.out.println("URL was malformed");
			}
			//System.out.println(line);
			//i++;
			//System.out.println("out loadGlossary(Glossary_db glossaryDB)");
		}
	}
	else
		System.out.println("there be no elements here");
	//glossaryDB.makeHtmlString();
	return  KeywordDB;
	}
/**
  * given the base of where the applet is running
 * the function will fill an instance of Modules_db with the names of each module
 * and an URL that reachies the index.htm of each module.
 * not cheching is done if said index.htm files exist.
 * also "/" is used as a separator which may not be platform independat
 * only file type expections are caught and the modules.txt file is expected to be syntacticly correct.
 * Creation date: (02/27/00 14:56:03)
 * @param url java.lang.String
 */
public void loadModules(String urlString)
{
	String modulesFile = new String(urlString.concat("modules/modules.txt"));
	String modURLString;
	URL url;
	URL moduleURL;
	LineNumberReader file;
	LineNumberReader file2;
	String about = new String();
	String line = new String();
	String line2 = new String();
	modules = new Modules_db(); //make sure that the Modules list is empty before filling it
	//System.out.println(modulesFile);
	try
	{
		url = new URL(modulesFile);
		try
		{
			file = new LineNumberReader(new InputStreamReader((url.openStream())));
			int i = 1;
			while (line != null)
			{
				try
				{
					line = file.readLine();
					//System.out.println(i);
					//System.out.println(line);
					if (line != null)
					{
						modURLString = new String(urlString);
						modURLString = modURLString.concat("modules/");
						modURLString = modURLString.concat(line);
						moduleURL = new URL(modURLString);
						try
						{ //System.out.println(modURLString);
							url = new URL((modURLString.concat("/about.htm")));
							try
							{
								file2 = new LineNumberReader(new InputStreamReader((url.openStream())));
								while (line2 != null)
								{
									try
									{
										line2 = file2.readLine();
										if (line2 != null)
										{
											about = about.concat(line2);
										}
									}
									catch (IOException e)
									{
										System.out.println("read line failed");
										line2 = null;
									}
								}
							}
							catch (IOException e)
							{
								System.out.println("The file about.htm  was unavailable for reading:");
							}
						}
						catch (MalformedURLException e)
						{
							System.out.println("URL is malformend");
						}


						//System.out.println("in loadModules(String urlString)");
						//System.out.println(modURLString);
						modules.addModule(line, moduleURL, about);
						line2 = new String();
						about = new String();
					}
					i++;
				}
				catch (IOException e)
				{
					System.out.println("read line failed");
					line = null;
				}
			}
		}
		catch (IOException e)
		{
			System.out.println("The file in the following module was unavailable for reading Modules:");
			System.out.println("modules.txt");
			System.out.println("\n the file was thought to be at:");
			System.out.println(modulesFile);
		}
	}
	catch (MalformedURLException e)
	{
		System.out.println("URL is malformend");
	}
	return;
}
}
